
import javax.persistence.*;
import java.io.Serializable;

@Entity
public class Sample implements Serializable {
    private static final long serialVersionUID = 9199877999376663312L;

    private String title;
    @OneToOne(fetch = FetchType.LAZY, cascade = CascadeType.ALL)
    private LargeString description;
    @OneToOne(fetch = FetchType.LAZY, cascade = CascadeType.ALL)
    private LargeString code;   

    public Sample() {
    }

    public Sample(String title, LargeString description, LargeString code) {
        this.title = title;
        this.description = description;
        this.code = code;
    }

    public String getTitle() {
        return title;
    }

    public LargeString getDescription() {
        return description;
    }

    public LargeString getCode() {
        return code;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public void setDescription(LargeString description) {
        this.description = description;
    }

    public void setCode(LargeString code) {
        this.code = code;
    }

    public static void main(String[] args) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("$objectdb/db/sample.odb");
        EntityManager em = emf.createEntityManager();
        Sample sample = new Sample("Title", new LargeString("info"), new LargeString("code"));
        em.getTransaction().begin();
        em.persist(sample);
        em.getTransaction().commit();
        em.flush();
        em.close();
        emf.close();
        //Close everything and reopen to make sure no cache of the description / code is left behind
        emf = Persistence.createEntityManagerFactory("$objectdb/db/sample.odb");
        em = emf.createEntityManager();
        sample = em.createQuery("select s from Sample s", Sample.class).getResultList().get(0);
        em.detach(sample); //just to be sure
        em.close();
        emf.close();

        System.out.println(sample.title);
        System.out.println(sample.description.getString());
        System.out.println(sample.code.getString());
    }
}
